<?php
declare(strict_types=1);

namespace Bitrix\KMsending\RemoteService\Dto\GroupSms;

class SmsResult
{
    /**
     * @var string $guid
     */
    protected $guid;

    /**
     * @var string $result
     */
    protected $result;

    public function __construct(
        string $guid,
        string $result
    ) {
        $this->guid = $guid;
        $this->result = $result;
    }

    /**
     * @return string
     */
    public function getGuid(): string
    {
        return $this->guid;
    }

    /**
     * @return string
     */
    public function getResult(): string
    {
        return $this->result;
    }


}