<?php
declare(strict_types=1);

namespace Bitrix\KMsending\RemoteService\Methods\Senders;

use Bitrix\KMsending\RemoteService;
use Bitrix\KMsending\Debug;

class MethodExecutor extends RemoteService\MethodExecutor\MethodExecutor
{

    /**
     * {@inheritdoc}
     */
    protected function getMethodName(): string
    {
        return 'senders';
    }

    /**
     * {@inheritdoc}
     */
    protected function prepareResponse($rawResponse)
    {
        $response = json_decode($rawResponse);
        return new Response(
            $response->type,
            $response->senders
        );
    }

}
