<?php

use \Bitrix\Main\Localization\Loc;

Loc::loadLanguageFile(__FILE__);

if ($GLOBALS['APPLICATION']->GetGroupRight('kmsending') !== 'D') {
    $aMenu = [
        'parent_menu' => 'global_menu_services',
        'section'     => 'KMsending',
        'sort'        => 100,
        'text'        => Loc::getMessage('KMSENDING_MAIN_MENU_MAIN'),
        'title'       => Loc::getMessage('KMSENDING_MAIN_MENU_MAIN_TITLE'),
        'url'         => 'kmsending_index.php?lang=' . LANGUAGE_ID,
        'icon'        => 'kmsending_menu_icon',
        'page_icon'   => 'kmsending_page_icon',
        'items_id'    => 'menu_kmsending',
        'items'       => [
            [
                'text'     => Loc::getMessage('KMSENDING_MAIN_SENDSMS'),
                'url'      => 'kmsending_sendsms.php?lang=' . LANGUAGE_ID,
                'title'    => Loc::getMessage('KMSENDING_MAIN_SENDSMS_ALT'),
                'more_url' => []
            ],
            [
                'text'     => Loc::getMessage('KMSENDING_MAIN_BALANCE'),
                'url'      => 'kmsending_balance.php?lang=' . LANGUAGE_ID,
                'title'    => Loc::getMessage('KMSENDING_MAIN_BALANCE_ALT'),
                'more_url' => []
            ],
            [
                'text'     => Loc::getMessage('KMSENDING_MAIN_SMS_LIST_OUT'),
                'url'      => 'kmsending_sms_out_list.php?lang=' . LANGUAGE_ID,
                'title'    => Loc::getMessage('KMSENDING_MAIN_SMS_LIST_OUT_ALT'),
                'more_url' => []
            ],
            [
                'text'     => Loc::getMessage('KMSENDING_MAIN_SMS_LIST_INC'),
                'url'      => 'kmsending_sms_inc_list.php?lang=' . LANGUAGE_ID,
                'title'    => Loc::getMessage('KMSENDING_MAIN_SMS_LIST_INC_ALT'),
                'more_url' => []
            ],
            [
                'text'     => Loc::getMessage('KMSENDING_MAIN_SMS_SETTINGS'),
                'url'      => '/bitrix/admin/settings.php?mid=kmsending&lang=' . LANGUAGE_ID,
                'title'    => Loc::getMessage('KMSENDING_MAIN_SMS_SETTINGS_ALT'),
                'more_url' => []
            ]
        ]
    ];

    return $aMenu;
}
return false;
