<?
namespace Bitrix\KMsending\Callback;

use Bitrix\KMsending\Exceptions\KMsendingRepositoryException;
use Bitrix\KMsending\Sendings;

require($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/include/prolog_before.php");
$send_guid=$_REQUEST['guid'];
//if (!is_string($send_guid) || (preg_match('/^[0-9a-f]{8}-[0-9a-f]{4}-4[0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/', $send_guid) !== 1)) {
if (empty($send_guid)) {
    http_response_code(500);
    die();
}

try {
    $repository= new Sendings\Messages\Repository();
    $message=$repository->getMessageBydGuid($send_guid);
} catch (\Exception $e) {

}
if(empty($message)) {
    http_response_code(500);
    die();
} else {
    $send_status=$_REQUEST['status'];
    $message->setLastModified(new \DateTime('now'));

    switch ($send_status) {
        case '0': $message->setStatus(new Sendings\Messages\Status(Sendings\Messages\Status::IN_PROCESS)); break;
        case '1': $message->setStatus(new Sendings\Messages\Status(Sendings\Messages\Status::STATUS_SEND)); break;
        //read
        case '2': $message->setStatus(new Sendings\Messages\Status(Sendings\Messages\Status::STATUS_SEND)) ;break;
        case '3': $message->setStatus(new Sendings\Messages\Status(Sendings\Messages\Status::STATUS_REJECTED)) ;break;
        //link
        case '4': $message->setStatus(new Sendings\Messages\Status(Sendings\Messages\Status::STATUS_SEND)) ;break;
        case '20':
        case '22':
        case '23':
        case '24':
        case '25':
            $message->setStatus(new Sendings\Messages\Status(Sendings\Messages\Status::NOT_SEND)) ;break;
    }
    $repository->saveOnce($message);
    http_response_code(200);
}
